module.exports = {
  id: 'Agent',
  type: 'object',
  prefixes: {
    '': 'http://schema.org/',
    'foaf': 'http://xmlns.com/foaf/0.1/',
    'holo': 'http://holodex.is/vocab/'
  },
  context: 'foaf:Agent',
  description: 'An agent.',
  properties: {
    name: {
      context: 'name',
      description: 'The primary name of the agent.',
      type: 'string'
    },
    description: {
      context: 'description',
      description: 'A short description of the agent.',
      type: 'string'
    },
    image: {
      context: 'image',
      description: 'An image of the agent',
      type: 'string',
      format: 'url'
    },
    roles: {
      context: 'holo:hasRoles',
      description: 'The roles the agent fills',
      type: 'array',
      items: {
        reverse: 'agent',
        $ref: 'Role'
      }
    },
    relationships: {
      context: 'holo:hasRelationship',
      description: 'The relationships the agent is in with other agents.',
      type: 'array',
      items: {
        reverse: ['roles', true, 'agent'],
        $ref: 'Relationship'
      }
    }
  }
}
