var express = require('express')
var sendJson = require('send-data/json')
var debug = require('debug')('holodex:api')

var Model = require('base/model')

module.exports = createApi

function createApi (config) {
  debug('config', config)

  var getGraph = require(config.data.db + '-db')

  var api = express()

  var graph
  var latestCommit
  var queue = []

  getGraph(config.data, function (err, gotGraph) {
    if (err) {
      throw err
    }
    
    debug('got graph', gotGraph)

    graph = gotGraph

    queue.forEach(function (cb) { cb() })
    queue = []
  })


  api.get('/*', function (req, res) {
    debug('get', req.path)
    if (graph == null) {
      queue.push(sendGraph.bind(null, req, res))
    } else {
      sendGraph(req, res)
    }
  })

  function sendGraph (req, res) {
    var json = {
      '@context': {},
      '@graph': graph.map(function (model) {
        return model.toJSON()
      })
    }
    sendJson(req, res, {
      statusCode: 200,
      body: json
    }, function (err) {
      if (err) { throw err }
    })
  }

  return api
}
