var debug = require('debug')('filter-options')

module.exports = function (queries) {
  return queries.inactive.reduce(function (memo, query) {
    var inverseQueryActive
    debug('query', query)

    if (query.component && query.component.inverse) {
      if (query.target) {
        var targetId = query.component.inverse.id + '.src.' + query.target.id
        if (queries.queryMap[targetId]) { inverseQueryActive = true }
      } else if (query.source && !inverseQueryActive) {
        var sourceId = query.component.inverse.id + '.tgt.' + query.source.id
        if (queries.queryMap[sourceId]) { inverseQueryActive = true }
      }
    }

    if (!inverseQueryActive && query.labels) {
      query.labels.forEach(function (label) { memo.push(label) })
    }

    return memo
  }, [])
}
