var React = require('react/addons')
var r = require('r-dom')
var debug = require('debug')('craftodex:ui:person:views:page')

var router = require('router')
var GraphView = require('graph-view/graph-view')
var ListView = require('list-view')
var Link = require('base/views/href')

// var vars = require('ui/vars')

var style = {
  profile: {
    position: 'relative'
  },

  profileName: {
    fontFamily: "'Helvetica Neue', Helvetica, Arial, sans-serif",
    fontWeight: 'bold'
  },

  profileAvatarDesktop: {
    background: '#fff',
    border: '5px solid #fff',
    borderRadius: 12,
    boxShadow: '0 1px 1px rgba(136,153,166,0.15)',
    height: 200,
    width: 200
  }
}

module.exports = React.createClass({
  mixins: [],

  propTypes: {
    model: React.PropTypes.object
  },

  componentDidMount: function () {
    this.props.model.on('change', function () {
      this.forceUpdate()
    }, this)
  },

  renderList: function () {
    return (
      r(ListView, {
        model: this.props.model
      })
    )
  },

  renderGraph: function () {
    var model = this.props.model
    // TODO actions
    var actions = {}

    return (
      r(GraphView, this.props)
    )
  },

  render: function () {
    var model = this.props.model
    var route = this.props.route

    debug('render', this.props)
    var view
    if (route.query.view === 'list') {
      view = this.renderList()
    } else {
      view = this.renderGraph()
    }

    return (
      r.div({}, [
        r.header({}, [
        ]),
        view
      ])
    )
  }
})
